library contentsquare;

import 'package:contentsquare/src/modules/gestures/cs_gesture_detector.dart';
import 'package:contentsquare/src/modules/screengraph/hit_test/get_tvp_at_hit_position.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import '../contentsquare.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatelessWidget {
  /// ContensquareRoot widget constructor
  const ContentsquareRoot({Key? key, required this.child}) : super(key: key);

  /// Child widget
  final Widget child;

  void _a186({
    required ContentsquareGesture a453,
    required Offset a454,
    ContentsquareGestureData? a455,
  }) {
    final a268 = a253(a454);

    
    
    for (var a269 in a268) {
      Contentsquare().sendTouchEvent(
        type: a453,
        version: version,
        data: TouchEventData(path: a269, gestureData: a455),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return a132(
      a82: (position) => _a186(
        a454: position,
        a453: ContentsquareGesture.tap,
      ),
      a81: (position) => _a186(
        a454: position,
        a453: ContentsquareGesture.longPress,
      ),
      a80: (position, data) => _a186(
        a454: position,
        a453: ContentsquareGesture.drag,
        a455: data,
      ),
      a79: (position, data) => _a186(
        a454: position,
        a453: ContentsquareGesture.flick,
        a455: data,
      ),
      a83: child,
    );
  }
}
