import 'dart:math';

import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import 'gesture_listener.dart';


class a132 extends StatelessWidget {
  
  final Widget a83;

  
  final Function(Offset position)? a82;

  
  final Function(Offset position)? a81;

  
  final Function(Offset position, ContentsquareGestureData data)? a80;

  
  final Function(Offset position, ContentsquareGestureData data)? a79;

  
  const a132({
    Key? a474,
    required this.a83,
    this.a82,
    this.a81,
    this.a80,
    this.a79,
  }) : super(key: a474);

  bool _a208(a126 a475) {
    return a475.a107.distance.isFinite && a475.a106.isFinite;
  }

  void _a209(PointerEvent a476) {
    a82?.call(a476.position);
  }

  void _a210(PointerEvent a477) {
    a81?.call(a477.position);
  }

  void _a211(a126 a478) {
    final a303 = _a212(a478.a107);
    if (a303 == null) return;

    if (!_a208(a478)) return;

    final a304 = ContentsquareGestureData(
      distance: a478.a107.distance.toInt(),
      direction: a303,
      velocity: max(a478.a106.dx.abs(), a478.a106.dy.abs()).toInt(),
    );

    if (a304.velocity >= kMinFlingVelocity) {
      a79?.call(a478.a108, a304);
    } else {
      a80?.call(a478.a108, a304);
    }
  }

  static ContentsquareGestureDirection? _a212(Offset a479) {
    if (a479.dx == 0 && a479.dy == 0) return null;

    if (a479.dx.abs() <= a479.dy.abs()) {
      /// Vertical Gesture
      /// gestureDirection = CSGestureDirection.down OR CSGestureDirection.up
      return a479.dy > 0
          ? ContentsquareGestureDirection.down
          : ContentsquareGestureDirection.up;
    }

    /// Horizontal Gesture
    /// gestureDirection = CSGestureDirection.right OR CSGestureDirection.left
    return a479.dx > 0
        ? ContentsquareGestureDirection.right
        : ContentsquareGestureDirection.left;
  }

  @override
  Widget build(BuildContext context) {
    return a127(
      a104: _a209,
      a103: _a210,
      a99: _a211,
      a105: a83,
    );
  }
}
