import 'dart:async';
import 'dart:developer' as dev;

import 'package:collection/collection.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


a115 get a187 => _a270;
var _a270 = a115._a188();


class a115 {
  a115._a188({void Function(a116 log)? a456}) {
    _a271.stream.listen(a456 ?? _a189);
  }

  
  void a39(a116 a450) => _a271.add(a450);

  
  void a38(String a449) => a39(a118(a449));

  
  void a37(String a448) => a39(a120(a448));

  
  void a36(String a447) => a39(a122(a447));

  
  void a35(String a446) => a39(a124(a446));

  final _a271 = StreamController<a116>.broadcast();

  
  void _a189(a116 a457) {
    const a272 = 80;

    
    final a273 = '─' * (a272 - 1);

    
    
    const a274 = a272 - 3;

    String _a190(String a458) {
      return a458
          ._a192(a460: a274)
          .map((line) => '│ $line')
          .join('\n');
    }

    final a275 = _a190(a457.a2);
    final a276 = _a190(a457.a8);

    
    
    
    dev.log(
      '\n'
      '┌$a273\n'
      '$a275\n'
      '├$a273\n'
      '$a276\n'
      '└$a273\n',
    );
  }

  
  @visibleForTesting
  void a34({
    required void Function(a116 log) a444,
    required void Function(VoidCallback) a445,
  }) {
    final a277 = _a270;

    _a270 = a115._a188(a456: a444);

    a445(() => _a270 = a277);
  }
}


@visibleForTesting
bool a191(String a459) {
  final a278 =
      a459.split('\n').where((line) => line.isNotEmpty).length;

  return a278 > 1;
}


abstract class a116 {
  
  @mustCallSuper
  String get a2 => '(CSLIB)';

  
  String get a8;

  /// String representation of the log.
  ///
  /// The string is formed by the prefix followed by the message. If the message
  /// is on multiple lines, a line break is used between the prefix and the
  /// message and a separator is put at the end of the string.
  @override
  @nonVirtual
  String toString() {
    const _a279 = '\n----------------------------------------------------';

    final _a280 =
        a191(a8) ? '\n$a8$_a279' : a8;

    return '$a2 $_a280';
  }
}

extension on String {
  
  IList<String> _a192({required int a460}) {
    final a281 = split('\n');

    return a281
        .map((line) {
          final a282 = line.split(' ');

          var a283 = IList<IList<String>>();
          var a284 = IList<String>();
          for (final a285 in a282) {
            if (a284.join(' ').length + a285.length + 1 > a460) {
              a283 = a283.add(a284);
              a284 = a284.clear();
            }
            a284 = a284.add(a285);
          }
          a283 = a283.add(a284);

          return a283.map((line) => line.join(' ').padRight(a460));
        })
        .flattened
        .toIList();
  }
}


mixin a117 on a116 {
  @override
  String get a2 => 'ℹ️ INFO ℹ️ ${super.a2}';
}


class a118 extends a116 with a117 {
  
  a118(this.a8);

  @override
  final String a8;
}


mixin a119 on a116 {
  @override
  String get a2 => '✅ SUCCESS ✅ ${super.a2}';
}


class a120 extends a116 with a119 {
  
  a120(this.a8);

  @override
  final String a8;
}


mixin a121 on a116 {
  @override
  String get a2 => '⚠️ WARNING ⚠️ ${super.a2}';
}


class a122 extends a116 with a121 {
  
  a122(this.a8);

  @override
  final String a8;
}


mixin a123 on a116 {
  @override
  String get a2 => '⛔️ ERROR ⛔️ ${super.a2}';
}


class a124 extends a116 with a123 {
  
  a124(this.a8);

  @override
  final String a8;
}
