import 'dart:collection';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../../logger/logger.dart';
import '../widgets_binding.dart';
import '../../webview_tracking/webview_tracking.dart';
import '../compression.dart';
import '../element_extension.dart';
import '../unmodifiable_list_view_extension.dart';
import 'get_element_data_of_hit_render_object.dart';
import 'hit_element_data.dart';
import 'results/hit_leaves_element_tvps_result.dart';
import 'results/hit_maybe_result.dart';

part 'get_leaves_element_tvps.dart';


UnmodifiableListView<String> a253(Offset a517) {
  final a372 = _a255(a517);

  final a373 = a263(
    a524: a372,
    a525: a140.a232(a494: a517),
  );

  a254() => UnmodifiableListView<String>([]);

  return a373.a13(
    a421: () {
      
      
      
      
      
      a187.a39(
        a151(
          a518: a517,
          a519: a372,
        ),
      );
      return a254();
    },
    a422: (hitElementData) {
      final a374 = hitElementData.a69.a85;
      if (a374.a225) {
        
        
        return a254();
      }

      final a375 = _a245(
        a513: hitElementData,
      );

      return a375.a9(
        
        a410: () => a254(),
        a411: (leavesScreengraphTVPs) {
          
          
          final a376 =
              leavesScreengraphTVPs.a252();

          final a377 =
              a376.map(a193).toList();

          return UnmodifiableListView(a377);
        },
      );
    },
  );
}


@visibleForTesting
class a151 extends a122 {
  
  a151({
    required Offset a518,
    required RenderObject a519,
  }) : super(
          'Could not find the element associated with the RenderObject '
          '$a519 that was found for the gesture at '
          '$a518',
        );
}


RenderObject _a255(Offset a520) {
  final a378 = a180.a207!.renderView;

  
  
  final a379 = BoxHitTestResult();
  a378.hitTest(a379, position: a520);

  
  return a379.path
      .firstWhere((element) => element.target is RenderObject)
      .target as RenderObject;
}
