import 'dart:developer';

import 'package:flutter/rendering.dart';


extension a183 on RenderObject {
  
  Rect? get a226 => _a228(a488: true);

  
  Rect? get a227 => _a228(a488: false);

  
  Rect? _a228({required bool a488}) {
    final a328 = this;

    
    
    
    
    
    if (a328 is RenderView) {
      
      
      
      
      return a328.child?._a228(
        a488: a488,
      );
    } else if (a328 is RenderBox) {
      return _a230(
        a328,
        a491: a488,
      );
    } else if (a328 is RenderSliver) {
      return _a231(
        a328,
        a493: a488,
      );
    } else {
      log(
        'The RenderObject of type ${a328.runtimeType} is not supported. '
        'Therefore its size cannot be determined.',
      );
      return null;
    }
  }

  
  Rect _a229({
    required bool a489,
  }) {
    if (!a489) {
      return paintBounds;
    }

    
    
    
    final a329 = getTransformTo(null).getTranslation();
    return paintBounds.shift(Offset(a329.x, a329.y));
  }
}


Rect? _a230(
  RenderBox a490, {
  required bool a491,
}) {
  if (!a490.hasSize) {
    return null;
  }

  return a490._a229(
    a489: a491,
  );
}


Rect? _a231(
  RenderSliver a492, {
  required bool a493,
}) {
  if (a492.geometry == null) {
    return null;
  }

  return a492._a229(
    a489: a493,
  );
}
