import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/modules/logger/logger.dart';
import 'package:contentsquare/src/modules/webview_tracking/adapters/js_event_to_dart_sdk_adapter.dart';
import 'package:contentsquare/src/modules/webview_tracking/javascript_event_handler.dart';
import 'package:contentsquare/src/modules/webview_tracking/logs/invalid_json_log.dart';
import 'package:contentsquare/src/modules/webview_tracking/logs/screengraph_retrieval_error_logs/tvp_not_found_log.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';


class a157 extends a166 {
  
  a157({
    required this.a51,
    required this.a50,
  });

  
  final Contentsquare a51;

  
  final String? Function() a50;

  
  static const _a381 = 'eventJson';

  
  @override
  final List<String> a0 = [_a381];

  @override
  Future<void> a12(Map<String, dynamic> a417) async {
    try {
      final a382 = a50();

      if (a382 == null) {
        a187.a39(a174());
        return;
      }

      final a383 = jsonDecode(a417[_a381]);

      final a384 = a383['type'];
      final a385 = ContentsquareGestureInt.fromInt(a384);

      final a386 = a383['data'];

      if (a385 == ContentsquareGesture.pageView) {
        final a387 = a386['url'];
        return a51.send(a387);
      }

      return a51.sendTouchEvent(
        type: a385,
        version: a383['version'],
        data: TouchEventData.fromJson(a386)
            .copyWithPrefixedPath('$a382|webview|'),
      );
    } catch (error) {
      a187.a39(
        a141(
          a495: ContentsquareJavascriptEventEnum.sendMessage,
          a496: '$error',
        ),
      );
    }
  }
}
