import 'package:contentsquare/src/modules/logger/logger.dart';

import 'webview_log.dart';


class a156 extends a124 with a139 {
  
  a156({
    required String? a521,
    required String a522,
  }) : super(
          '''
WebView tracking initialization failed${a521 == null ? '' : ' on WebView with initialUrl: $a521'}.

Reason: $a522
          
                
The expected [ContentsquareWebViewTrackerBuilder] usage is:
```dart
ContentsquareWebViewTrackerBuilder(
  builder: (context, tracker) => WebView(
    onPageFinished: tracker.onPageFinished,
    onWebViewCreated: tracker.onWebViewCreated,
    javascriptChannels: tracker.javascriptChannels,
    javascriptMode: JavascriptMode.unrestricted,
    initialUrl: 'https://tupeuxpastest.csq.io/mobile/web-view-cart.html',
  ),
)
          ''',
        );
}
